/*LCD.C
LCD routines for KS0066U ( samsung ) and PIC16F87X

Written by: Neagoe Gabriel
Email:		admin@codsursa.ro

Copyrigth info: This sources can be used in any commercial application and for educational purposes ...
*/

#include "lcd.h"

void lcd_write(unsigned char c)
{
	LCD_DB7 = (c >> 7) &0x01;
	LCD_DB6 = (c >> 6) &0x01;
	LCD_DB5 = (c >> 5) &0x01;
	LCD_DB4 = (c >> 4) &0x01;
	LCD_STROBE;

	LCD_DB7 = (c >> 3) &0x01;
	LCD_DB6 = (c >> 2) &0x01;
	LCD_DB5 = (c >> 1) &0x01;
	LCD_DB4 =  c & 0x01;
	LCD_STROBE;
	DelayUs(80);

//	PORTB = (PORTB & 0xF0) |  (c >> 4);
//	LCD_STROBE;
//	PORTB = (PORTB & 0xF0) |  (c & 0x0F);
//	LCD_STROBE;
//	DelayUs(80);
}

void lcd_clear(void)
{
	LCD_RS = 0;
	lcd_write(0x01);
	DelayMs(4);
}

void lcd_puts(const char * s)
{
	LCD_RS = 1;	// write characters
	while(*s)
		lcd_write(*s++);
}

void lcd_putch(char c)
{
	LCD_RS = 1;	// write characters
	PORTB = (PORTB & 0xF0) |  (c >> 4);
	LCD_STROBE;
	PORTB = (PORTB & 0xF0) |  (c & 0x0F);
	LCD_STROBE;
	DelayUs(80);
}

void lcd_goto(unsigned char pos)
{
	LCD_RS = 0;
	lcd_write(0x80 + pos);
}
	
void lcd_init(void)
{
	LCD_RS = 0;
	LCD_RW = 0;
	DelayMs(150);

	PORTB = (PORTB & 0xF0) | 0x2;
	LCD_STROBE;
	LCD_STROBE;
	PORTB = (PORTB & 0xF0) | 0x0C;
	LCD_STROBE;
	DelayUs(80);
	
	PORTB = (PORTB & 0xF0);
	LCD_STROBE;
	PORTB = (PORTB & 0xF0) | 0x0C;
	LCD_STROBE;
	DelayUs(80);

	PORTB = (PORTB & 0xF0);
	LCD_STROBE;
	PORTB = (PORTB & 0xF0) | 0x01;
	LCD_STROBE;
	DelayMs(4);
	
	PORTB = (PORTB & 0xF0);
	LCD_STROBE;
	PORTB = (PORTB & 0xF0) | 0x06;
	LCD_STROBE;
	DelayUs(80);
}

